"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var function_1 = require("fp-ts/lib/function");
var observerVoid = {
    next: function_1.constVoid,
    end: function_1.constVoid,
};
function useSink(M) {
    return function (factory, dependencies) {
        var sa = react_1.useMemo(factory, dependencies);
        react_1.useEffect(function () {
            var subscription = M.subscribe(sa.effects, observerVoid);
            return function () { return subscription.unsubscribe(); };
        }, [sa]);
        return sa.value;
    };
}
exports.useSink = useSink;
//# sourceMappingURL=use-sink.js.map